package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10069MHQReasult;
import cn.net.cpzslibs.prot.handset.bean.Prot10069SeedMHQBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10069MHQGetProduct extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10069 = 10069;
	private Gson gson;
	private Prot10069MHQReasult res;

	public Prot10069MHQGetProduct() {

		gson = new Gson();
	}

	

	public Prot10069MHQReasult getRes() {
		return res;
	}



	public void setRes(Prot10069MHQReasult res) {
		this.res = res;
	}



	public void dealGetMHQProduct(SocketCreate create,
                                  Prot10069SeedMHQBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10069SeedMHQBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10069, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recDealer(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recDealer(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10069, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10069, jsonData);

		if (!StrUtils.isEmpty(jsonData)) {

			res = gson.fromJson(jsonData, Prot10069MHQReasult.class);
		}
		recCheckCode(dis);
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10069SeedMHQBean reqBean)
			throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10069, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
